
include graphics.inc
includelib Graphics.lib

fInitControl proto

    ImageCodecInfo STRUCT
      ClassID           CLSID <>
      FormatID          GUID <>
      CodecName         DWORD ?
      DllName           DWORD ?
      FormatDescription DWORD ?
      FilenameExtension DWORD ?
      MimeType          DWORD ?
      Flags             DWORD ?
      Version           DWORD ?
      SigCount          DWORD ?
      SigSize           DWORD ?
      SigPattern        DWORD ?
      SigMask           DWORD ?
    ImageCodecInfo ENDS
    
GdiplusStartupInput struct
	GdiplusStartupInput dword 0
	DebugEventCallbac dword 0
	SuppressBackgroundThread dword 0
	SuppressExternalCodecs dword 0
GdiplusStartupInput ends
    
fShape struc
	mDC 		dword 0
	hBitmap		dword 0
	_width		dword 0
	height		dword 0
	PointCount	dword 0
	lpPOINT		dword 0
fShape ends

MU_EAX equ 0
MU_MMX equ 1
MU_XMM equ 2

.DATA
ALIGN 16
Sprite_Simd_Mask_RVB_unpck_1 DWORD 000010001h,000000001h
Sprite_Simd_Mask_RVB_unpck_255 DWORD 000FF00FFh,0000000FFh

	gdipsi              GdiplusStartupInput <1>  ; version must be 1
	token               dd 0
	image               dd 0
	numEncoders         dd 0
    sizeImageCodecInfo  dd 0
    pImageCodecInfo     dd 0
    
.code

FSaveDIBToBitmap proc hBmp:dword,lptzFileName:dword
	LOCAL hFile
	
	invoke CreateFile,lptzFileName,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,NULL,NULL
	mov hFile, eax
	invoke SaveDIB32,hBmp,hFile
	invoke CloseHandle,hFile
	
	ret
FSaveDIBToBitmap endp

fPicSaveToFileAsJpg proc uses esi edi lpFileName:dword
	LOCAL str_len,tmp_esi:dword
	LOCAL buff[256],buff2[256],buff3[256]:dword
	
	invoke exist,lpFileName
	.if eax==0
		invoke MessageBox,0,0,0,0
		ret
	.endif
	
	invoke GdiplusStartup, ADDR token, ADDR gdipsi, NULL
		invoke MultiByteToWideChar,0,0,lpFileName,-1,addr buff3,1024
		invoke GdipLoadImageFromFile, addr buff3, ADDR image
		invoke GdipGetImageEncodersSize, ADDR numEncoders,ADDR sizeImageCodecInfo
		invoke mAlloc,sizeImageCodecInfo
		.if eax==0
			invoke MessageBox,0,CADD("Not Enough memory/Memori tidak cukup"),0,0
			jmp error
		.endif
		mov pImageCodecInfo,eax
		invoke GdipGetImageEncoders, numEncoders, sizeImageCodecInfo,pImageCodecInfo
				invoke lstrlen,lpFileName
				mov str_len,eax
				sub str_len,2
				invoke lstrcpyn,addr buff,lpFileName,str_len
				invoke lstrcat,addr buff,CADD("jpg")
				
				assume esi:ptr ImageCodecInfo
					mov ecx,numEncoders
					mov esi,pImageCodecInfo
					@@:
					push ecx
					push esi
					mov tmp_esi,esi
					invoke WideCharToMultiByte,0,0,[esi].MimeType,-1,addr buff2,1024,0,0
					invoke lstrcmp,addr buff2,CADD("image/jpeg")
					.if eax==0
						invoke MultiByteToWideChar,0,0,addr buff,-1,addr buff3,1024
						invoke GdipSaveImageToFile, image, addr buff3,tmp_esi, NULL
						pop esi
						pop ecx
						jmp error
					.endif
					pop esi
					add esi, SIZEOF ImageCodecInfo
					pop ecx
					dec ecx
					jnz @b
				assume esi:nothing
		
		error:		
	invoke GdipDisposeImage, image
	invoke GdiplusShutdown, token
	invoke GlobalFree,pImageCodecInfo
	
	ret
fPicSaveToFileAsJpg endp

fShapeMakeFont proc uses esi lpsf:dword,pointSize:DWORD,weight:DWORD,italic:DWORD,lpFontName:DWORD
	
	mov esi,lpsf
	invoke MakeFont,pointSize,weight,italic,lpFontName
	push eax
	invoke SelectObject,[esi],eax
	pop eax
	invoke DeleteObject,eax
	
	ret
fShapeMakeFont endp

fCenterWindows proc hWnd:dword,_width:dword,height:dword
	LOCAL xs,ys:dword
	LOCAL hxs,hys:dword
	
	invoke GetSystemMetrics,SM_CXSCREEN
	mov xs,eax
	shr eax,1
	mov hxs,eax
	invoke GetSystemMetrics,SM_CYSCREEN
	mov ys,eax
	shr eax,1
	mov hys,eax
	
	mov eax,_width
	shr eax,1
	sub hxs,eax
	
	mov eax,height
	shr eax,1
	sub hys,eax
	
	invoke SetWindowPos,hWnd,HWND_NOTOPMOST,hxs,hys,_width,height,NULL
	
	ret
fCenterWindows endp

fGetBitmapDimension proc hmDC:dword
	LOCAL bm:BITMAP
	
	invoke GetObject,hmDC,sizeof BITMAP,addr bm
	mov edx,bm.bmWidth
	mov eax, bm.bmHeight
	
	ret
fGetBitmapDimension endp

NewLayer proc l:dword,t:Dword
	LOCAL mdc:Dword
	LOCAL mbmp:dword
	
	invoke CreateCompatibleDC,hDC
	mov mdc,eax
	invoke CreateCompatibleBitmap,hDC,l,t
	mov mbmp,eax
	
	invoke SelectObject,mdc,eax
	invoke CreateFontIndirect,addr FontStrucGUI
	invoke SelectObject,mdc,eax
	
	mov edx,mdc
	mov eax,mbmp
	
	
	ret
NewLayer endp

fLoadPicture proc uses esi edi wDC:dword,mDC:dword,x:dword,y:dword,l:dword,t:dword,filename:dword
	LOCAL buff[512],hMemDC,hBitmap,mptr,err_code:dword
	LOCAL file_size:dword
		
		mov err_code,0
		invoke exist,filename
		.if eax!=1
		;	invoke MessageBox,NULL,filename,NULL,MB_OK
			xor eax,eax
			dec eax
			ret
		.endif
		
		invoke filesize,filename
		mov file_size,eax
		invoke mAlloc,eax
		mov mptr,eax
		invoke Buka,mptr,filename,addr err_code,file_size
		invoke BitmapFromMemory,mptr,file_size
		.if eax==0
			invoke PERR
			invoke MessageBox,NULL,filename,NULL,MB_OK
			xor eax,eax
			dec eax
			ret
		.endif
		mov	hBitmap,eax
		invoke	CreateCompatibleDC,wDC
		mov	hMemDC,eax
		invoke	SelectObject,eax,hBitmap
		invoke	BitBlt,mDC,x,y,l,t,hMemDC,0,0,SRCCOPY
		
		
		invoke 	DeleteObject,hBitmap
		invoke	DeleteDC,hMemDC		
	invoke GlobalFree,mptr
	
	ret
fLoadPicture endp

fLoadPicture2 proc filename:dword
	LOCAL buff[512],hMemDC,hBitmap,mptr,err_code:dword
	LOCAL file_size:dword
		
		mov err_code,0
		invoke exist,filename
		.if eax!=1
		;	invoke MessageBox,NULL,filename,NULL,MB_OK
			xor eax,eax
			dec eax
			ret
		.endif
		
		invoke filesize,filename
		mov file_size,eax
		invoke mAlloc,eax
		mov mptr,eax
		invoke Buka,mptr,filename,addr err_code,file_size
		invoke BitmapFromMemory,mptr,file_size
		.if eax==0
			invoke PERR
			invoke MessageBox,NULL,filename,NULL,MB_OK
			xor eax,eax
			dec eax
			ret
		.endif
		mov	hBitmap,eax
		invoke GlobalFree,mptr
		
		mov eax,hBitmap
		
	
	ret
fLoadPicture2 endp

GetDimension proc uses esi edi BitmapHandle:dword,lpBitmapStructure:dword
	
	invoke GetObject,BitmapHandle,sizeof BITMAP,lpBitmapStructure
	
	ret
GetDimension endp

; System screen
GetMainScreenAddress proc
	
	mov eax,main_screen
	
	ret
GetMainScreenAddress endp

GetBitmapPointer proc
	
	mov eax,pointer_bitmap2
	
	ret
GetBitmapPointer endp

GetBitMapAddress proc
	
	mov eax,pointer_bitmap2
	
	ret
GetBitMapAddress endp

GetBitMapHandle proc
	
	mov eax,hBmpGUI
	
	ret
GetBitMapHandle endp

GetMainScreenDC proc
	
	mov eax,mDCGUI
	
	ret
GetMainScreenDC endp

SetBitmapPointer proc bmppnt:dword
	
	mov eax,bmppnt
	mov pointer_bitmap2,eax
	
	ret
SetBitmapPointer endp

; Transfer pixel


TransferPixel proc uses esi edi dest:dword,sou:dword,machine_used:dword
	mov esi,sou
	mov edi,dest
	
	mov eax,machine_used
	xor ecx,ecx
	cmp eax,ecx
	jz use_eax
	inc ecx
	cmp eax,ecx
	jz use_mmx
	inc ecx
	cmp eax,ecx
	jz use_xmm
		xor eax,eax
		dec eax
		ret
	; change ecx depend on width resolution used
	use_eax:
		mov ecx,1024*4
		shr ecx,2
		xor edx,edx
		@@:
			mov eax,[esi+edx*4]
			mov [edi+edx*4],eax
		inc edx
		dec ecx
		jnz @b
		
		ret
	use_mmx:
		mov ecx,1024*4
		shr ecx,3
		xor edx,edx
		@@:
			movq mm0,[esi+edx*8]
			movq [edi+edx*8],mm0
		inc edx
		dec ecx
		jnz @b
		
	use_xmm:
		mov ecx,1024*4
		shr ecx,4
		xor edx,edx
		@@:
			movups xmm0,[esi+edx]
			movups [edi+edx],xmm0
		add edx,16
		dec ecx
		jnz @b
		
	ret
TransferPixel endp

TransferPixelFull proc uses esi edi 
	LOCAL dib_mem,mscr_mem:Dword
	LOCAL cntr:dword
	
	mov edi,pointer_bitmap
	mov esi,main_screen
	
	mov dib_mem,edi
	mov mscr_mem,esi
	
	xor edx,edx
	mov cntr,edx
	mov ecx,767
	@@:
	push ecx
		invoke PosCount2,0,ecx
		shl eax,2
		mov edi,dib_mem
		add edi,eax
		invoke PosCount2,0,cntr
		shl eax,2
		mov esi,mscr_mem
		add esi,eax
			invoke TransferPixel,edi,esi,MU_EAX
	pop ecx
	inc cntr
	dec ecx
	jnz @b
		
		
	ret
TransferPixelFull endp


RetrievePixel proc uses esi edi dest:dword,sou:dword,machine_used:dword
	mov esi,sou
	mov edi,dest
	
	mov eax,machine_used
	xor ecx,ecx
	cmp eax,ecx
	jz use_eax
	inc ecx
	cmp eax,ecx
	jz use_mmx
	inc ecx
	cmp eax,ecx
	jz use_xmm
		xor eax,eax
		dec eax
		ret
	; change ecx depend on width resolution used
	use_eax:
		mov ecx,1024*4
		shr ecx,2
		xor edx,edx
		@@:
			mov eax,[edi+edx*4]
			mov [esi+edx*4],eax
		inc edx
		dec ecx
		jnz @b
		
		ret
	use_mmx:
		mov ecx,1024*4
		shr ecx,3
		xor edx,edx
		@@:
			movq mm0,[edi+edx*8]
			movq [esi+edx*8],mm0
		inc edx
		dec ecx
		jnz @b
		
	use_xmm:
		mov ecx,1024*4
		shr ecx,4
		xor edx,edx
		@@:
			movups xmm0,[edi+edx]
			movups [esi+edx],xmm0
		add edx,16
		dec ecx
		jnz @b
	
	ret
RetrievePixel endp

RetrievePixelFull proc uses esi edi 
	LOCAL dib_mem,mscr_mem:Dword
	LOCAL cntr:dword
	
	mov edi,pointer_bitmap2
	mov esi,main_screen
	
	mov dib_mem,edi
	mov mscr_mem,esi
	
	xor edx,edx
	mov cntr,edx
	mov ecx,767
	@@:
	push ecx
		invoke PosCount2,0,ecx
		shl eax,2
		mov edi,dib_mem
		add edi,eax
		invoke PosCount2,0,cntr
		shl eax,2
		mov esi,mscr_mem
		add esi,eax
			invoke RetrievePixel,edi,esi,MU_XMM
	pop ecx
	inc cntr
	dec ecx
	jnz @b
		
		
	ret
RetrievePixelFull endp

; Direct draw the screen
frbPixelPut proc uses esi edi x:dword,y:dword,color:dword
	
	mov edi,pointer_bitmap2
	mov ecx,768
	sub ecx,y
	invoke PosCount,x,ecx,1024,768
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov edx,color
	mov [edi+eax*4+2],dl
	mov [edi+eax*4+1],dh
	shr edx,16
	mov [edi+eax*4+0],dl
	
	ret
frbPixelPut endp

frbPixelPut2 proc uses esi edi x:dword,y:dword,color:dword
	; This function use look up table.
	; The first PixelPut is still faster than this function
	
	mov edi,pointer_bitmap2
	mov ecx,768
	sub ecx,y
	invoke PosCount2,x,ecx
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov edx,color
	mov [edi+eax*4+2],dl
	mov [edi+eax*4+1],dh
	shr edx,16
	mov [edi+eax*4+0],dl
	
	ret
frbPixelPut2 endp

frbPixelGet proc uses esi edi x:dword,y:dword
	
	mov edi,pointer_bitmap2
	mov ecx,768
	sub ecx,y
	invoke PosCount,x,ecx,1024,768
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov eax,[edi+eax*4]
	
	ret
frbPixelGet endp

frbPixelGet2 proc uses esi edi x:dword,y:dword
	; This function use look up table.
	; The first PixelPut is still faster than this function
	
	mov edi,pointer_bitmap2
	mov ecx,768
	sub ecx,y
	invoke PosCount2,x,ecx
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov eax,[edi+eax*4]	
	ret
frbPixelGet2 endp



; For draw buffer
FrbPixelPut proc uses esi edi x:dword,y:dword,color:dword
	
	mov edi,main_screen
	invoke PosCount,x,y,1024,768
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov edx,color
	mov [edi+eax*4+2],dl ;r
	mov [edi+eax*4+1],dh ;g
	shr edx,16
	mov [edi+eax*4+0],dl ;b
	
	ret
FrbPixelPut endp

FrbPixelPut2 proc uses esi edi x:dword,y:dword,color:dword
	; This function use look up table.
	; The first PixelPut is still faster than this function
	
	mov edi,main_screen
	invoke PosCount2,x,y
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov edx,color
	mov [edi+eax*4+2],dl
	mov [edi+eax*4+1],dh
	shr edx,16
	mov [edi+eax*4+0],dl
	
	ret
FrbPixelPut2 endp

FrbPixelGet proc uses esi edi x:dword,y:dword
	
	mov edi,main_screen
	invoke PosCount,x,y,1024,768
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov dl,[edi+eax*4+0]
	shl edx,16
	mov dh,[edi+eax*4+1]
	mov dl,[edi+eax*4+2]
	
	mov eax,edx
	
	ret
FrbPixelGet endp

FrbPixelGet2 proc uses esi edi x:dword,y:dword
	; This function use look up table.
	; The first PixelPut is still faster than this function
	
	mov edi,main_screen
	invoke PosCount2,x,y
	cmp eax,-1
	jnz @f
		ret
	@@:
	mov eax,[edi+eax*4]	
	ret
FrbPixelGet2 endp


FillScreen proc uses esi edi color:dword

	
	mov edi,main_screen
	mov ecx,(1024*768)
	mov eax,color
	shl eax,8
	bswap eax
	xor edx,edx
	@@:
		mov [edi+edx*4],eax
	inc edx
	dec ecx
	jnz @b
	
	
	ret
FillScreen endp

BlankScreen proc uses esi edi
	
	mov edi,pointer_bitmap2
	mov ecx,(1024*768)
	shr ecx,1
	pxor mm0,mm0
	@@:
	movq [edi+ecx*8],mm0
	dec ecx
	jnz @b
	
	
	ret
BlankScreen endp

BlankScreenBuffer proc uses esi edi
	
	invoke GetMainScreenAddress
	mov edi,eax
	mov ecx,(1024*768)
	shr ecx,1
	pxor mm0,mm0
	@@:
	movq [edi+ecx*8],mm0
	dec ecx
	jnz @b
	
	
	ret
BlankScreenBuffer endp

Circle proc uses esi edi x:dword, y:dword,w:dword,h:dword,color:dword
	LOCAL rot,posr_x,posr_y:dword
	
	mov ecx,3600
	circle_loop:
		push ecx
			invoke UMGetPosRound,w,ecx
		pop ecx
		mov posr_x,edx
		push ecx
			invoke UMGetPosRound,h,ecx
		pop ecx
		mov posr_y,eax
		
		mov eax,x
		add posr_x,eax
		mov eax,y
		add posr_y,eax
		push ecx
		invoke frbPixelPut2,posr_x,posr_y,color
		pop ecx
	sub ecx,1
	jnz circle_loop
	
	ret
Circle endp

Line proc uses esi edi x:dword,y:dword,x2:dword,y2:dword,color:dword
	LOCAL nDX,nDY,hyp:dword
	
	
	invoke GetDeltaXY,x,y,x2,y2
	mov nDX,edx
	mov nDY,eax
	invoke GetHypotenusa,nDX,nDY
	mov hyp,eax
		
	cmp hyp,0
	jle brs
	
	mov ecx,hyp
	
	@@:
	push ecx
		invoke GetPosLine,nDX,nDY,hyp,ecx
		add edx,x
		add eax,y
		invoke frbPixelPut,edx,eax,color
	pop ecx
	dec ecx
	jnz @b
	
	brs:
	
	
	ret
Line endp

CircleGradient proc uses esi edi x:dword,y:dword,w:dword,color:dword
	LOCAL tmp_edx,tmp_ecx:dword
	LOCAL r,g,b:dword
	LOCAL actl_clr:dword
	
	mov eax,color
	movzx ecx,al
	shr eax,8
	movzx edx,al
	shr eax,8
	movzx eax,al
	
	shr ecx,1
	shr edx,1
	shr eax,1
	
	mov b,ecx
	mov g,edx
	mov r,eax
	
	mov ecx,w
	xor edx,edx
	loop_start:
	mov tmp_edx,edx
	mov tmp_ecx,ecx
		invoke fGrad,tmp_edx,w,b
		add eax,b
		mov actl_clr,eax
		invoke fGrad,tmp_edx,w,g
		add eax,g
		shl eax,8
		or actl_clr,eax
		invoke fGrad,tmp_edx,w,r
		add eax,r
		shl eax,8
		or actl_clr,eax
		invoke Circle,x,y,tmp_ecx,tmp_ecx,actl_clr
	mov ecx,tmp_ecx
	mov edx,tmp_edx
	inc edx
	dec ecx
	jnz loop_start
	
	ret
CircleGradient endp

CircleShading proc uses esi edi x:dword,y:dword,w:dword,color:dword
	LOCAL tmp_edx,tmp_ecx:dword
	LOCAL r,g,b:dword
	LOCAL actl_clr:dword
	
	mov eax,color
	movzx ecx,al
	shr eax,8
	movzx edx,al
	shr eax,8
	movzx eax,al
	
	mov b,ecx
	mov g,edx
	mov r,eax
	
	mov ecx,w
	xor edx,edx
	loop_start:
	mov tmp_edx,edx
	mov tmp_ecx,ecx
		invoke fGrad,tmp_edx,w,b
		mov actl_clr,eax
		invoke fGrad,tmp_edx,w,g
		shl eax,8
		or actl_clr,eax
		invoke fGrad,tmp_edx,w,r
		shl eax,8
		or actl_clr,eax
		invoke Circle,x,y,tmp_ecx,tmp_ecx,actl_clr
	mov ecx,tmp_ecx
	mov edx,tmp_edx
	inc edx
	dec ecx
	jnz loop_start
	
	ret
CircleShading endp

RectGradient proc uses esi edi x:dword,y:dword,w:dword,h:dword,color:dword
	LOCAL tmp_edx,tmp_ecx:dword
	LOCAL r,g,b:dword
	LOCAL actl_clr:dword
	
	mov eax,color
	movzx ecx,al
	movzx edx,ah
	shr eax,16
	
	shr ecx,1
	shr edx,1
	shr eax,1
	
	mov r,ecx
	mov g,edx
	mov b,eax
	
	mov ecx,h
	xor edx,edx
	loop_start:
	mov tmp_edx,edx
	mov tmp_ecx,ecx
		invoke fGrad,tmp_ecx,h,r
		add eax,r
		mov actl_clr,eax
		invoke fGrad,tmp_ecx,h,g
		add eax,g
		shl eax,8
		or actl_clr,eax
		invoke fGrad,tmp_ecx,h,b
		add eax,b
		shl eax,16
		or actl_clr,eax
		
		mov edx,tmp_edx
		add edx,y
		
		mov ecx,x
		add ecx,w
		invoke Line,x,edx,ecx,edx,actl_clr
	mov ecx,tmp_ecx
	mov edx,tmp_edx
	inc edx
	dec ecx
	jnz loop_start
	
	
	ret
RectGradient endp

BlendPixel proc uses esi edi pixel:dword, pixel2:dword
	LOCAL r,g,b:dword
	LOCAL r2,g2,b2:dword
	LOCAL c1,c2:dword
	
	mov edx,pixel
	mov eax,pixel2
	
	bswap edx
	bswap eax
	
	mov c1,edx
	mov c2,eax
	
	lea esi,c1
	lea edi,c2
	
	movzx eax,byte ptr[esi+3]
	mov r,eax
	movzx eax,byte ptr[esi+2]
	mov g,eax
	movzx eax,byte ptr[esi+1]
	mov b,eax
	
	movzx eax,byte ptr[edi+3]
	mov r2,eax
	movzx eax,byte ptr[edi+2]
	mov g2,eax
	movzx eax,byte ptr[edi+1]
	mov b2,eax
	
	mov eax,r
	add r2,eax
	mov eax,g
	add g2,eax
	mov eax,b
	add b2,eax
	
	shr r2,1
	shr g2,1
	shr b2,1
	
	mov eax,b2
	shl eax,8
	or eax,g2
	shl eax,8
	or eax,r2
	
	
	ret
BlendPixel endp

BlendPixel2 proc uses esi edi pixel:dword, pixel2:dword,percent:dword
	LOCAL r,g,b:dword
	LOCAL r2,g2,b2:dword
	LOCAL c1,c2:dword
	LOCAL rat:Dword
	
	mov edx,pixel
	mov eax,pixel2
	
	bswap edx
	bswap eax
	
	mov c1,edx
	mov c2,eax
	
	lea esi,c1
	lea edi,c2
	
	movzx eax,byte ptr[esi+3]
	mov r,eax
	movzx eax,byte ptr[esi+2]
	mov g,eax
	movzx eax,byte ptr[esi+1]
	mov b,eax
	
	movzx eax,byte ptr[edi+3]
	mov r2,eax
	movzx eax,byte ptr[edi+2]
	mov g2,eax
	movzx eax,byte ptr[edi+1]
	mov b2,eax

	mov ecx,100
	sub ecx,percent
	mov rat,ecx
	
	invoke fGrad,rat,100,r
	mov r,eax
	invoke fGrad,rat,100,g
	mov g,eax
	invoke fGrad,rat,100,b
	mov b,eax
	
	invoke fGrad,percent,100,r2
	mov r2,eax
	invoke fGrad,percent,100,g2
	mov g2,eax
	invoke fGrad,percent,100,b2
	mov b2,eax
	
	
	mov eax,r
	add r2,eax
	mov eax,g
	add g2,eax
	mov eax,b
	add b2,eax
	
;	shr r2,1
;	shr g2,1
;	shr b2,1
	
	mov eax,b2
	shl eax,8
	or eax,g2
	shl eax,8
	or eax,r2
	
	
	ret
BlendPixel2 endp


BlendPixel3 proc pixel:dword,pixel2:dword,percent:dword

mov eax,100
sub eax,percent
mov percent,eax

mov eax,percent ; 0 to 100
mov edx,0FFh
mul edx
mov edx,42949673
mul edx ; become 0 to 255 in edx

shl edx,24 ; A,_,_,_

mov eax,pixel ; _,R,G,B read pixel
or eax,edx ; A,R,G,B add alpha
mov edx,pixel2 ; _,R,G,B read pixel2

pxor MM7,MM7 ; MM7 = 0,0,0,0 , 0,0,0,0
movq MM6,QWORD PTR Sprite_Simd_Mask_RVB_unpck_1 ; MM6 = 0,0,0,1 , 0,1,0,1
movd MM1,eax ; MM1 = _,_,_,_ , A,R,G,B (pixel)
movd MM0,edx ; MM0 = _,_,_,_ , A,R,G,B (pixel2)
punpcklbw MM1,MM7 ; MM1 = 0,A,0,R , 0,G,0,B
punpcklbw MM0,MM7 ; MM0 = 0,A,0,R , 0,G,0,B
movq MM2,MM1 ; MM2 = 0,A,0,R , 0,G,0,B
pshufw MM2,MM2,0FFh ; MM2 = 0,A,0,A , 0,A,0,A
movq MM3,QWORD PTR Sprite_Simd_Mask_RVB_unpck_255 ; MM3 = 0,0,0,255 , 0,255,0,255
psubw MM3,MM2 ; MM3 = 0,~A,0,~A , 0,~A,0,~A
paddw MM2,MM6 ; MM2 = 0,A+1,0,A+1 , 0,A+1,0,A+1
paddw MM3,MM6 ; MM3 = 0,~A+1,0,~A+1 , 0,~A+1,0,~A+1
pmullw MM1,MM2 ; MM1 = A*A,R*A , G*A,B*A
pmullw MM0,MM3 ; MM0 = A*0,R*A , G*A,B*A
paddw MM0,MM1 ; MM0 = A*0+A*0,R*A+R*A , G*A+G*A,B*A+B*A
psrlw MM0,8 ; MM0 = 0,A,0,R , 0,G,0,B
packuswb MM0,MM7 ; MM0 = _,_,_,_ , A,R,G,B
movd eax,MM0 ; A,R,G,B new

and eax,000FFFFFFh ; _,R,G,B only keep RGB

ret
BlendPixel3 endp

GetPixelPatern proc pixel:dword
	LOCAL pattern:dword
	
	mov pattern,0
	mov eax,pixel
	cmp al,0
	jna @f
		or pattern,1b
	@@:
	cmp ah,0
	jna @f
		or pattern,10b
	@@:
	shr eax,16
	cmp al,0
	jna @f
		or pattern,100b
	@@:
	mov eax,pattern
	
	ret
GetPixelPatern endp

fRectTransparent proc uses esi edi x:dword,y:dword,l:dword,t:dword,color:dword
	LOCAL posX,posY:dword
	LOCAL maxX,maxY:dword
	
	push y
	pop posY
	
	mov eax,t
	mov maxY,eax
	loop_y:
	push x
	pop posX
	mov ecx,l
	
	mov eax,l
	mov maxX,eax
	loop_x:
	push ecx
		invoke frbPixelGet,posX,posY
		bswap eax
		shr eax,8
		invoke BlendPixel,color,eax
		invoke frbPixelPut,posX,posY,eax
	pop ecx
	inc posX
	dec ecx
	jnz loop_x
	inc posY
	dec maxY
	jnz loop_y
	
	ret
fRectTransparent endp


fCreateShape1 proc l:dword,t:dword,color:Dword
	LOCAL pmem:dword
	; structure are
	; 0 mDC
	; 4 hBitmap
	; 8 l
	; 12 t
	; 16 8
	; 20-finish the POINT
	
	invoke mAlloc,8+8+4+(6*4*2)
	mov pmem,eax
	
	mov edx,t
	shl edx,1
	invoke NewLayer,l,edx
	mov ecx,pmem
	mov [ecx],edx
	mov [ecx+4],eax
	push l
	pop [ecx+8]
	push t
	pop [ecx+12]
	mov dword ptr[ecx+16],6
	
	xor edx,edx
	xor eax,eax
	
	add ecx,20
	mov [ecx],edx
	mov [ecx+4],eax
	
	push ecx
		mov ecx,l
		shr ecx,2
		add edx,ecx
	pop ecx
	mov [ecx+8],edx
	mov [ecx+12],eax
	
	add eax,20
	add edx,20
	mov [ecx+16],edx
	mov [ecx+20],eax
	
	add edx,l
	sub edx,30
	mov [ecx+24],edx
	mov [ecx+28],eax
	
	add eax,t
	sub eax,20
	mov [ecx+32],edx
	mov [ecx+36],eax
	
	xor edx,edx
	mov [ecx+40],edx
	mov [ecx+44],eax
	
	mov ecx,pmem
	invoke GetStockObject,WHITE_BRUSH
	mov ecx,pmem
	invoke SelectObject,[ecx],eax
	invoke GetStockObject,WHITE_PEN
	mov ecx,pmem
	invoke SelectObject,[ecx],eax
	mov ecx,pmem
	
	mov edx,ecx
	add edx,20
	invoke Polygon,[ecx],edx,[ecx+16]
	
	invoke RectGradient,0,0,l,t,color
	mov ecx,pmem
	invoke BitBlt,[ecx],0,t,l,t,[ecx],0,0,NOTSRCCOPY
	mov ecx,pmem
	invoke BitBlt,[ecx],0,0,l,t,mDCGUI2,0,0,SRCAND
		
	mov eax,pmem
	
	ret
fCreateShape1 endp

fCreateShape proc l:dword,t:dword,color:dword
	LOCAL pmem:dword
	
	invoke mAlloc,8+8+4+(6*4*2)
	mov pmem,eax
	
	mov edx,t
	shl edx,1
	invoke NewLayer,l,edx
	mov ecx,pmem
	mov [ecx],edx
	mov [ecx+4],eax
	push l
	pop [ecx+8]
	push t
	pop [ecx+12]
	mov eax,pmem
	
	invoke RectGradient,0,0,l,t,color
	mov eax,pmem
	
	ret
fCreateShape endp

fCreateCircle proc uses esi edi radius:DWORD,color:dword
	LOCAL pmem:dword
	LOCAL x_pos,y_pos:dword
	
	; 0 mDC
	; 4 hBitmap
	; 8 radius
	; 12 radius
	; 16 POINT struct
	;
	
	invoke GetStockObject,BLACK_BRUSH
	invoke SelectObject,mDCGUI2,eax
	mov edx,radius
	shl edx,1
	invoke Rectangle,mDCGUI2,0,0,edx,edx
	
	invoke mAlloc,24
	mov pmem,eax
	mov esi,eax
	invoke mAlloc,36*2*4
	mov [esi+16],eax
	
	mov edx,radius
	shl edx,1
	mov eax,edx
	shl eax,1
	mov [esi+8],edx
	mov [esi+12],edx
	invoke NewLayer,edx,eax
	mov [esi],edx
	mov [esi+4],eax
	
	xor edx,edx
	xor eax,eax
	
	add edx,radius
	add eax, radius
	mov edi,[esi+16]
	
	mov ecx,3600
	loop_circle:
	push ecx
		mov edx,radius
		sub edx,3
		invoke UMGetPosRound,edx,ecx
		add edx,radius
		add eax,radius
		mov [edi],edx
		mov [edi+4],eax
	pop ecx
	add edi,8
	sub ecx,100
	cmp ecx,0
	ja loop_circle
	
	
	invoke GetStockObject,WHITE_BRUSH
	invoke SelectObject,[esi],eax
	invoke GetStockObject,WHITE_PEN
	invoke SelectObject,[esi],eax
	
	invoke Polygon,[esi],[esi+16],36
	
	invoke RectGradient,0,0,[esi+8],[esi+12],color
	invoke BitBlt,[esi],0,[esi+12],[esi+8],[esi+12],[esi],0,0,NOTSRCCOPY
	invoke BitBlt,[esi],0,0,[esi+8],[esi+12],mDCGUI2,1,1,SRCAND
	
	invoke GlobalFree,[esi+16]
	mov eax,esi
	
	ret
fCreateCircle endp

fDestroyShape proc uses esi edi lps:dword
	; structure are
	; 0 mDC
	; 4 hBitmap
	; 8 l
	; 12 t
	; 16 8
	; 20-finish the POINT
	
	mov esi,lps
	invoke DeleteObject,[esi+4]
	invoke DeleteDC,[esi]
	invoke GlobalFree,esi
	
	ret
fDestroyShape endp

fShapeIsInside proc uses esi shp1:dword,x:dword,y:dword,xmouse:dword,ymouse:dword
	
	mov esi,shp1
	mov edx,xmouse
	mov eax,ymouse
	sub edx,x
	sub eax,y
	
	cmp edx,0
	jnl @f
		ret
	@@:
	cmp eax,0
	jnl @f
		ret
	@@:
	
	add eax,[esi+12]
	invoke GetPixel,[esi],edx,eax
	.if eax==0
		xor eax,eax
		inc eax
	.else
		xor eax,eax
	.endif
	
	ret
fShapeIsInside endp

fCreateShapeFromBitmapDC proc uses esi edi bitmaphandledc:dword,l:dword,t:dword
	LOCAL pmem:dword	
	; structure are
	; 0 mDC
	; 4 hBitmap
	; 8 l
	; 12 t
	; 16 8
	; 20-finish the POINT
	
	invoke mAlloc,8+8+4+(6*4*2)
	mov pmem,eax
	mov esi,eax
	
	mov edx,t
	shl edx,1
	invoke NewLayer,l,edx
	mov ecx,pmem
	mov [ecx],edx
	mov [ecx+4],eax
	push l
	pop [ecx+8]
	push t
	pop [ecx+12]
	
	invoke BitBlt,[esi],0,0,l,t,bitmaphandledc,0,0,SRCCOPY
	invoke BitBlt,[esi],0,t,l,t,bitmaphandledc,0,t,SRCCOPY
	
	mov eax,pmem
	
	ret
fCreateShapeFromBitmapDC endp
; y=0 is the bitmap
; y=t is the bitmap mask
fDrawShape proc uses esi edi lpStruct:Dword,mDC:Dword,x:dword,y:dword,blend_ratio:dword
	LOCAL posX,posY:dword
	LOCAL maxX,maxY:dword
	LOCAL pixel:dword
	
	mov esi,lpStruct
	cmp blend_ratio,100
	jz full_copy
	cmp blend_ratio,0
	ja transparent
	full_copy:
		invoke BitBlt,mDC,x,y,[esi+8],[esi+12],[esi],0,[esi+12],SRCAND
		invoke BitBlt,mDC,x,y,[esi+8],[esi+12],[esi],0,0,SRCPAINT
		ret
	transparent:
	invoke BitBlt,mDCGUI2,0,0,[esi+8],[esi+12],mDC,x,y,SRCCOPY
	invoke BitBlt,mDCGUI2,0,[esi+12],[esi+8],[esi+12],[esi],0,0,SRCCOPY
	
	xor edx,edx
	xor eax,eax
	loop_vertical:
		push edx
		push eax
			mov posX,edx
			mov posY,eax
			add eax,[esi+12]
			invoke frbPixelGet,posX,eax
			bswap eax
			shr eax,8
			mov pixel,eax
			cmp eax,0
			jz no_need
			invoke frbPixelGet,posX,posY
			bswap eax
			shr eax,8
			invoke BlendPixel3,eax,pixel,blend_ratio
			invoke frbPixelPut,posX,posY,eax
			no_need:
		pop eax
		pop edx
	inc edx
	cmp edx,[esi+8]
	jle loop_vertical
	xor edx,edx
	inc eax
	cmp eax,[esi+12]
	jle loop_vertical
	
	mov eax,[esi+12]
	dec eax
	invoke BitBlt,mDC,x,y,[esi+8],eax,mDCGUI2,0,0,SRCCOPY
	
	ret
fDrawShape endp

fShapePutText proc uses esi edi lpStruct:dword,x:dword,y:dword,lpText:dword,color:dword
		
	; structure are
	; 0 mDC
	; 4 hBitmap
	; 8 l
	; 12 t
	; 16 8
	; 20-finish the POINT
	
	mov esi,lpStruct
	invoke SetTextColor,[esi],color
	invoke SetBkMode,[esi],TRANSPARENT
	invoke szLen,lpText
	invoke TextOut,[esi],x,y,lpText,eax
	
	ret
fShapePutText endp

fCheckColorPatern proc uses esi edi mDC:dword,x:dword,y:dword,l:dword,t:dword
	LOCAL color_buff[8]:dword
	LOCAL pattern,last_pattern:Dword
	LOCAL pos_x,pos_y:dword
	LOCAL counter:dword
	
	invoke BitBlt,mDCGUI2,0,0,l,t,mDC,x,y,SRCCOPY
	
	xor eax,eax
	mov last_pattern,eax
	
	xor edx,edx
	xor eax,eax
	loop_x:
	push edx
	push eax
		mov pattern,0
		mov pos_x,edx
		mov pos_y,eax
		invoke frbPixelGet,pos_x,pos_y
		bswap eax
		shr eax,8
		cmp al,0
		jna @f
			or pattern,1b
		@@:
		cmp ah,0
		jna @f
			or pattern,10b
		@@:
		shr eax,16
		cmp al,0
		jna @f
			or pattern,100b
		@@:
		mov eax,last_pattern
		cmp eax,pattern
		jnz @f
			xor eax,eax
			invoke frbPixelPut,pos_x,pos_y,eax
		@@:
	pop eax
	pop edx
	inc edx
	cmp edx,l
	jle loop_x
	xor edx,edx
	inc eax
	cmp eax,t
	jle loop_x
	
	
	ret
fCheckColorPatern endp

fCreateShapeRoundRect proc uses esi edi x:Dword,y:Dword,x2:Dword,y2:Dword,x3:Dword,y3:Dword,color:dword
	LOCAL lps,l,t:Dword
	; structure are
	; 0 mDC
	; 4 hBitmap
	; 8 l
	; 12 t
	; 16 8
	; 20-finish the POINT
	invoke GetDeltaXY,x,y,x2,y2
	mov l,edx
	mov t,eax
	invoke fCreateShape,edx,eax,color
	mov esi,eax
	mov lps,esi
	invoke GetStockObject,WHITE_BRUSH
	invoke SelectObject,[esi],eax
	invoke GetStockObject,WHITE_PEN
	invoke SelectObject,[esi],eax
	
	invoke RoundRect,[esi],x,y,x2,y2,30,30
	
	invoke BitBlt,[esi],0,t,l,t,[esi],0,0,NOTSRCCOPY
	
	invoke BitBlt,[esi],0,0,l,t,mDCGUI2,0,0,SRCAND
	mov eax,lps
	
	ret
fCreateShapeRoundRect endp

fCreateShapeFromFile proc uses esi edi wDC:dword,l:dword,t:dword,filename:dword,maskfilename:dword	
	LOCAL lps:Dword
	LOCAL pmem:dword
	; structure are
	; 0 mDC
	; 4 hBitmap
	; 8 l
	; 12 t
	; 16 8
	; 20-finish the POINT
	
	invoke mAlloc,8+8+4+(6*4*2)
	mov pmem,eax
	mov esi,eax
	
	mov edx,t
	shl edx,1
	invoke NewLayer,l,edx
	mov ecx,pmem
	mov [ecx],edx
	mov [ecx+4],eax
	push l
	pop [ecx+8]
	push t
	pop [ecx+12]
	mov eax,pmem
	
	invoke fLoadPicture,wDC,[esi],0,0,l,t,filename
	invoke fLoadPicture,wDC,[esi],0,t,l,t,maskfilename
	
	mov eax,pmem
	ret
fCreateShapeFromFile endp

fCreateShapeFromBitmap proc uses esi edi wDC:dword,l:dword,t:dword,color:dword
	LOCAL lps,vt:dword
	
	invoke fCreateShape,l,t,color
	mov esi,eax
	mov lps,esi
	
	push t
	pop vt
	shr vt,1
	
	invoke BitBlt,[esi],0,0,l,t,wDC,0,0,SRCCOPY
	invoke BitBlt,[esi],0,t,l,t,[esi],0,0,NOTSRCCOPY
	invoke BitBlt,[esi],0,0,l,t,mDCGUI2,0,0,SRCAND
	mov eax,lps
	
	ret
fCreateShapeFromBitmap endp