GetTextIndex  proto :dword,:dword,:dword,:dword,:dword
GetTextIndex2 proto :dword,:dword,:dword,:dword,:dword,:dword
GetOffsetIndex proto :dword,:dword,:dword

LineCheck proto :dword,:dword
LineCount proto :dword,:dword
LineLength proto :dword,:dword
CopyDW proto :dword,:dword,:dword

CreateOffsetTable proto :dword,:dword,:dword,:dword
GetOffsetTable proto :dword,:dword,:dword
GetTextTable proto :dword,:dword,:dword,:dword,:dword

CharToDW proto :dword,:dword

OpenFileFrb proto :dword
TextFromFile proto :dword,:dword
Word_Count proto :dword,:dword
Word_position proto :dword,:dword,:dword
CreateWordTable proto lpsf:dword
GetWord proto lpsf:dword,colm:dword,ind:dword
UM_Word_Count proto lpsf:dword,colm:dword
UM_LineLength proto lpsf:dword,dwInd:dword
DestroyWordTable proto :dword

PERR proto

.const
MAX_SZEXPAND_LENGTH                equ        1024
HKCR                                equ        HKEY_CLASSES_ROOT
HKCU                                equ        HKEY_CURRENT_USER
HKLM                                equ        HKEY_LOCAL_MACHINE
REGISTRY_OPERATION_SUCCESS        equ        0
REGISTRY_OPEN_FAILED                equ        1
REGISTRY_QUERY_INITIAL_FAILED        equ        2
REGISTRY_MISMATCH_FAILED        equ        3
REGISTRY_QUERY_ACTUAL_FAILED        equ        4
REGISTRY_CLOSE_FAILED                equ        5
REGISTRY_CREATE_FAILED                equ        6
REGISTRY_SETVALUE_FAILED        equ        7
REGISTRY_DELETE_FAILED                equ        8

.data
 szFileName    db 260 dup(0)
wfd WIN32_FIND_DATA<>


.code

Registry_ReadValue	proc	hKeyRoot:HKEY,pszSubKey:LPCTSTR,pszKeyName:LPCTSTR,pTarget:LPBYTE,dwDataType:DWORD
	LOCAL	hKey:HKEY
	LOCAL	dwReturnType:DWORD
	LOCAL	dwSize:DWORD
	LOCAL	szExpandBuffer[1024]:BYTE
	LOCAL	dwReturnValue:DWORD
	
	push	esi

	mov	dwReturnValue, REGISTRY_OPERATION_SUCCESS

	;try to open key
	invoke	RegOpenKeyEx,hKeyRoot,pszSubKey,0,KEY_READ,addr hKey
	.if	eax != ERROR_SUCCESS
		mov	dwReturnValue, REGISTRY_OPEN_FAILED
		jmp	@f
	.endif
	
	mov	esi,pTarget
	mov	byte ptr [esi],0
	
	;try to understand datatype of pszKeyValue
	invoke	RegQueryValueEx,hKey,pszKeyName,0,addr dwReturnType,0,addr dwSize
	.if	eax != ERROR_SUCCESS
		mov	dwReturnValue, REGISTRY_QUERY_INITIAL_FAILED
		jmp	@f
	.endif
	
	;check for datatype mismatch
	mov	eax,dwReturnType
	.if	eax != dwDataType
		mov	dwReturnValue, REGISTRY_MISMATCH_FAILED
		jmp	@f
	.endif
	
	;read actual data
	invoke	RegQueryValueEx,hKey,pszKeyName,0,addr dwReturnType,pTarget,addr dwSize
	.if	eax != ERROR_SUCCESS
		mov	dwReturnValue, REGISTRY_QUERY_ACTUAL_FAILED
		jmp	@f
	.endif
	
	;special case
	.if	dwDataType == REG_EXPAND_SZ
		invoke	ExpandEnvironmentStrings,addr szExpandBuffer,pTarget,1024
		
		invoke	lstrcpy,pTarget,addr szExpandBuffer
	.endif
	
	;we know what this is :)
	invoke	RegCloseKey,hKey
	.if	eax != ERROR_SUCCESS
		mov	dwReturnValue, REGISTRY_CLOSE_FAILED
		jmp	@f
	.endif
@@:
	pop	esi

	mov	eax, dwReturnValue
	ret
Registry_ReadValue	endp

fGetComputerName proc uses esi lptz:dword
	
	
	ret
fGetComputerName endp

fSearchChar proc uses esi lptz:dword,char:byte
	
	mov esi,lptz
	invoke lstrlen,lptz
	mov ecx,eax
	@@:
	mov al,[esi]
	inc esi
	dec ecx
	jz error
	cmp al,char
	jz done
	jmp @b
	
	error:
	xor eax,eax
	dec eax
	ret
	done:
	sub esi,lptz
	mov eax,esi
	dec eax
	ret
fSearchChar endp

Get_Folder_From_Exe PROC a_psz_exe,a_psz_folder:DWORD

	mov	esi,[a_psz_exe]
	xor	ecx,ecx
loop_exe_folder:
	lodsb
	.IF	al=="\"		;memo pos
		mov	ecx,esi
		sub	ecx,[a_psz_exe]
		jmp	loop_exe_folder
	.ENDIF
	test	al,al
	jnz	loop_exe_folder
;copy
	mov	esi,[a_psz_exe]
	mov	edi,[a_psz_folder]
	cld
	rep	movsb
	mov	eax,edi
	sub	eax,[a_psz_exe]
	.IF	eax>3
		mov	BYTE PTR [edi-1],0
	.ELSE
		mov	BYTE PTR [edi],0
	.ENDIF

ret
Get_Folder_From_Exe ENDP

fSetCurrentDirectory proc hInst:dword
	LOCAL buff[256]:dword
	LOCAL t[256]:dword
	
	invoke	GetModuleFileName,hInst,addr buff,1024
	invoke	Get_Folder_From_Exe,addr buff,addr t
	invoke	SetCurrentDirectory,addr t
	
	ret
fSetCurrentDirectory endp

fCreatePipe proc uses esi edi hWnd:dword,ModuleName:dword,CommandLine:dword
	LOCAL sat:SECURITY_ATTRIBUTES
	LOCAL hRead:DWORD
	LOCAL hWrite:DWORD
	LOCAL startupinfo:STARTUPINFO
	LOCAL pinfo:PROCESS_INFORMATION
	LOCAL buffer[1024]:byte
	LOCAL bytesRead:DWORD
	
	mov sat.nLength,sizeof SECURITY_ATTRIBUTES
	mov sat.lpSecurityDescriptor,NULL
	mov sat.bInheritHandle,TRUE
	invoke CreatePipe,addr hRead,addr hWrite,addr sat,NULL
	.if eax==NULL
		dec eax
		push eax
			invoke MessageBox,hWnd,CADD("Fail at create pipe"),NULL,MB_OK
		pop eax
	.else
		mov startupinfo.cb,sizeof STARTUPINFO
		invoke GetStartupInfo,addr startupinfo
		mov eax,hWrite
		mov startupinfo.hStdOutput,eax
		mov startupinfo.hStdError,eax
		mov startupinfo.dwFlags,STARTF_USESHOWWINDOW+STARTF_USESTDHANDLES
		mov startupinfo.wShowWindow,SW_HIDE
		;-------------------------------------------------
		; Create process
		;-------------------------------------------------
		invoke CreateProcess,ModuleName,CommandLine,NULL,NULL,TRUE,NULL,NULL,NULL,addr startupinfo,addr pinfo
		.if eax==NULL
			dec eax
			push eax
				invoke PERR
				invoke MessageBox,hWnd,CADD("Fail at create process"),NULL,MB_OK
			pop eax
		.else
			invoke CloseHandle,hWrite
			@@:
			invoke ReadFile,hRead,addr buffer,1023,addr bytesRead,NULL
			push eax
				invoke MessageBox,hWnd,addr buffer,NULL,MB_OK
			pop eax
			cmp eax,1
			jz @b
		.endif
		
	.endif
	push eax
	invoke CloseHandle,hRead
	pop eax
	
	ret
fCreatePipe endp

PERR	PROC uses ebx edi esi	;, _API : DWORD
LOCAL	szMsgBuf[500]:BYTE

	INVOKE GetLastError
	mov	ebx, eax
	INVOKE FormatMessage, \
		FORMAT_MESSAGE_FROM_SYSTEM,\
		NULL, \
		ebx, \					;Message Id
		LANG_NEUTRAL + SUBLANG_DEFAULT*1024, \	;Message language
		ADDR szMsgBuf, \			;Buffer to store message
		500, \					;Buffer size
		NULL					;No more arguments
	INVOKE	MessageBox, NULL, ADDR szMsgBuf, NULL, MB_OK

	;INVOKE	ExitProcess, -1

	ret

PERR	ENDP

GetFileName proc uses esi hParent:DWORD,lpTitle:DWORD,lpFilter:DWORD
	LOCAL ofn         :  OPENFILENAME ; structure

   mov ofn.lStructSize,        sizeof OPENFILENAME
   push 0
   pop ofn.hWndOwner
   push 0
   pop ofn.hInstance
   push lpFilter
   pop ofn.lpstrFilter
   push offset szFileName
   pop ofn.lpstrFile
   mov ofn.nMaxFile,           sizeof szFileName
   push lpTitle
   pop ofn.lpstrTitle
   mov ofn.Flags,              OFN_EXPLORER or OFN_FILEMUSTEXIST or \
                               OFN_LONGNAMES

   invoke GetOpenFileName,ADDR ofn
   ret

GetFileName endp

fOpenFileDialog proc hWnd:dword,lpszTitleO:dword,lpszFilterO:dword
	
    
           invoke memfill,ADDR szFileName,length szFileName,0
           invoke GetFileName,hWnd, lpszTitleO, lpszFilterO
           
           .if eax!=0
    	       lea eax,szFileName
           .endif
	ret
fOpenFileDialog endp

CharToDW proc lptz:dword,base:dword
	
	pop edx			; 1-byte EIP
	pop ecx			; 1-byte base
	pop esi			; 1-byte lptz
		push edx	; 1-byte EIP
	xor edx,edx		; 2-byte
	
	dloop:
	mov al,[esi]
	cmp al,'A'
	jae it_hex_lch
	cmp al,'a'
	jae it_hex_uch
	cmp al,'0'
	jae it_num
	cmp al,0
	jz done
	cmp al,13
	jz done
		; error
		xor ecx,ecx
		dec ecx
		ret
it_hex_lch:
	sub al,'a'
	add al,10
	jmp keep
it_hex_uch:
	sub al,'A'
	add al,10
	jmp keep
it_num:
	and al,0fh
keep:
	mul cl
	add edx,eax
	xor ecx,ecx
	inc esi
	inc ch
	jmp dloop

done:
	ret
CharToDW endp	; edx:hiDword,eax:loDword,ecx:status

CreateOffsetTable proc uses esi edi  lpSou:dword,lpTbl:dword,FileSize:dword,lnCnt:dword
	;LOCAL rslt,Pos:dword
	
	
	mov esi,lpSou
	mov edi,lpTbl
		
	xor ecx,ecx
		mov [edi],ecx
		add edi,4
	dloop:
	mov dl,[esi]
		inc ecx
	cmp dl,10
	jnz go
		inc eax
		mov [edi],ecx
		add edi,4
	go:
	inc esi
	cmp ecx,FileSize
	jl dloop
	
	
	ret
CreateOffsetTable endp

GetOffsetTable proc uses esi edi nPos:dword,lpTbl:dword,nMaxPos:dword
	
	mov esi,lpTbl
	mov ecx,nPos
	mov edx,nMaxPos
	
	cmp ecx,edx
	jae brs
		xor eax,eax
		cmp ecx,eax
		jle brs
			dec ecx
			mov eax,[esi+ecx*4]
			ret
	brs:
		xor eax,eax
		dec eax
	ret
GetOffsetTable endp

GetTextTable proc uses esi edi nPos:dword,lpTbl:dword,nMaxPos:dword,lpDest:dword,lpSou:dword
	
	invoke GetOffsetTable,nPos,lpTbl,nMaxPos
	cmp eax,-1
	jz brs
	
	mov esi,lpSou
	mov edi,lpDest
	add edi,eax
	xor ecx,ecx
		mloop:
		inc ecx
		lodsb
		stosb
				cmp al,0
				jz __done
				cmp al,9
				jz mloop
				cmp al,';'
				jz __done
			cmp al,13
			jnz mloop
	__done:
		dec edi
	mov byte ptr[edi],0
	xchg eax,ecx
	
	brs:
	ret
GetTextTable endp

LineLength proc uses esi lpHrp:dword,FileSize:dword
	
	mov esi,lpHrp
	xor ecx,ecx
	mloop:
	inc ecx
	mov al,[esi]
	inc esi
	cmp al,13
	jnz go
		mov eax,ecx
		jmp brs
	go:
	cmp al,0
	jnz go2
		mov eax,ecx
		jmp brs
	go2:
	cmp ecx,FileSize
	jl mloop
	xor eax,eax
	dec eax
	
	brs:
	ret
LineLength endp

LineCount proc uses esi edi lpTheFile:dword,FileSize:dword
	
	mov esi,lpTheFile

	
	xor ecx,ecx
	xor eax,eax
	inc eax
	inc eax
	
	dloop:
	mov dl,[esi]
	cmp dl,13
	jnz @f
		inc eax
	@@:
	inc esi
	inc ecx
	cmp ecx,FileSize
	jl dloop
	
	
	ret
LineCount endp

;New function here

OpenFileFrb proc uses esi edi lptz:dword
	LOCAL w,p,pf,filesz:dword
	; Memory for structur
	; 0  header = txt1
	; 4  lpmem file
	; 8  lpmem line table
	; 12 dword size
	; 16 line count
	; 20 for use with process function
	; 24 for use with word function
	; 28 word count
	
	invoke exist,lptz
	cmp eax,1
	jz @f
		xor eax,eax
		dec eax
		ret
	@@:
	
	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,32
	mov p,eax
	mov esi,eax
	; Header write on
	mov dword ptr[esi],'TXT1'
	;lpmem file
	invoke filesize,lptz
	mov filesz,eax
	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,filesz
	mov [esi+4],eax
	invoke Buka,[esi+4],lptz,addr w,filesz
	; Line Table
	invoke LineCount,[esi+4],w
	shl eax,2
	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov [esi+8],eax
	invoke CreateOffsetTable,[esi+4],[esi+8],w,NULL
	xor ecx,ecx
	cmp eax,ecx
	jnz @f
		invoke GlobalFree,[esi+4]
		invoke GlobalFree,[esi+8]
		invoke GlobalFree,p
		xor eax,eax
		dec eax
		ret
	@@:
	; size
	mov eax,w
	mov dword ptr[esi+12],eax
	; line count
	invoke LineCount,[esi+4],[esi+12]
	mov [esi+16],eax
	
	invoke CreateWordTable,p
	
	
	mov eax,p
	
	
	ret
OpenFileFrb endp

CloseFileFrb proc uses esi edi lpsf:dword
	; Memory for structur
	; 0  header = txt1
	; 4  lpmem file
	; 8  lpmem line table
	; 12 dword size
	; 16 line count
	; 20 for use with process function
	; 24 for use with word function
	; 28 word count
	
	mov esi,lpsf
	cmp esi,0
	jnz @f
		ret
	@@:
	invoke GlobalFree,[esi+4]
	invoke GlobalFree,[esi+8]
	invoke DestroyWordTable,esi
	invoke GlobalFree,esi
	
	mov lpsf,0
	
	ret
CloseFileFrb endp

TextFromFile proc uses esi edi nInd:dword,lpfile:dword
	
	mov esi,lpfile
		
	invoke GetOffsetTable,nInd,[esi+8],[esi+16]
	add eax,[esi+4]
		
	push eax
		invoke UM_LineLength,lpfile,nInd
	pop edx
	
	ret
TextFromFile endp	; edx=the address, eax the size


Word_Count proc uses esi edi lptz:dword,nSize:dword
	LOCAL stts,sizech,p:dword
		
	mov esi,lptz
	mov ecx,nSize
	
	xor eax,eax
	mov stts,eax
	mov edx,eax
	
	cmp nSize,0
	jnz @f
		xor eax,eax
		ret
	@@:
		
	loop_each_word:
		mov al,[esi]
		cmp al,039h			; 39 is '1'
		ja not_number
			cmp al,030h
			jl not_number
;				mov eax,stts
;				cmp eax,1
;				jz not_number					
					mov sizech,esi
					mov stts,1
			jmp not_ilegal_char				
		not_number:
		
		mov al,[esi]
		cmp al,05ah			; 059h is 'Z'
		ja not_char_up
			cmp al,041h
			jl not_char_up
;				mov eax,stts
;				cmp eax,1
;				jz not_char_up
					mov sizech,esi
					mov stts,1
			jmp not_ilegal_char
		not_char_up:
		
		mov al,[esi]
		cmp al,07ah			; 07ah is 'z'
		ja not_char_low
			cmp al,061h
			jl not_char_low
		;		cmp stts,1
		;		jz not_char_low
					mov sizech,esi
					mov stts,1
			jmp not_ilegal_char
		not_char_low:
		
		mov eax,stts
		cmp eax,1
		jnz not_ilegal_char
			inc edx
			dec eax
			mov stts,eax
			sub sizech,esi
				xchg edx,sizech
				sub edx,esi
				xchg edx,sizech
			
	not_ilegal_char:
	inc esi
	dec ecx
	jnz loop_each_word
	
	cmp stts,1
	jnz @f
		inc edx
	@@:
	
	mov eax,edx
	
	ret
Word_Count endp

Word_position proc uses esi edi nPos:dword,lptz:dword,nSize:dword
	LOCAL stts,sizech,p,ttc:dword
	
	mov esi,lptz
	mov ecx,nSize
	
	xor eax,eax
	mov stts,eax
	mov sizech,eax
	mov edx,eax
	
	cmp nSize,0
	jnz @f
		xor eax,eax
		ret
	@@:
	
	loop_each_word:
	mov al,[esi]
	
	cmp al,'a'
	jnae not_low
		cmp al,'z'
		jnle not_low
			cmp stts,1
			jz point_jmp
				mov stts,1
				mov sizech,esi
				jmp point_jmp
	not_low:
	
	cmp al,'A'
	jnae not_high
		cmp al,060h
		jnle not_high
			cmp stts,1
			jz point_jmp
				mov stts,1	
				mov sizech,esi
				jmp point_jmp	
	not_high:
	
	cmp al,021h
	jnae not_number
		cmp al,040h
		jnle not_number
			cmp stts,1
			jz point_jmp
				mov stts,1
				mov sizech,esi
				jmp point_jmp
	not_number:
	
	cmp stts,1
	jnz point_jmp
		inc edx
		mov stts,0
			cmp edx,nPos
			jz done	
	point_jmp:
	inc esi
	dec ecx
	jnz loop_each_word
	
	; On the latest version the last word is not detected.
	cmp stts,1
	jnz failed
		inc edx
		mov stts,0
			cmp edx,nPos
			jz done
	failed:
	xor eax,eax
	ret
	
	done:
	mov edx,sizech		; address
	mov eax,sizech		; size of the word
	sub esi,eax
	mov eax,esi			; 
	
	ret
Word_position endp

CreateWordTable proc uses esi edi lpsf:dword
	LOCAL tmp[20]:dword
	LOCAL w_cnt,lew_cnt,w_ptr,td,ta:dword
	LOCAL td1,tc1,offst:dword
	; This function will create a word table filled with offset and size
	
	mov esi,lpsf
	lea edi,tmp
	
	
	mov edx,[esi+16]
	shl edx,2
	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,edx
	mov [esi+24],eax
	mov dword ptr[eax],"NANO"

	mov edx,[esi+16]
	shl edx,2
	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,edx
	mov [esi+28],eax
;	mov dword ptr[eax],"NANO"
	
	
	mov td1,1
	mov ecx,[esi+16]
	loop_each_lines:
	push ecx
		invoke TextFromFile,td1,lpsf
		invoke Word_Count,edx,eax
		mov w_cnt,eax
		cmp eax,0
		jle no_word
		; For word count
		pushad
			mov edx,[esi+28]
			mov ecx,td1
			dec ecx
			mov [edx+ecx*4],eax
		popad
		xchg eax,edx
		shl edx,2
			invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,edx
			mov w_ptr,eax
			mov edx,[esi+24]
			mov ecx,td1
			dec ecx
			mov [edx+ecx*4],eax
						
			mov tc1,1
			loop_each_word:
			push eax
				invoke TextFromFile,td1,lpsf
				invoke Word_position,tc1,edx,eax
				push edx
				push eax
					invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,20
					mov ecx,eax					
				pop eax
				pop edx
				mov dword ptr[ecx],"FFFF"	; Header
				mov [ecx+4],edx				; offset
				mov [ecx+8],eax				; size
				mov eax,w_cnt
				mov [ecx+12],eax			; word count
			pop eax
			
			mov edx,tc1
			dec edx
			mov [eax+edx*4],ecx
			
			inc tc1
			dec w_cnt
			jnz loop_each_word
		no_word:
	pop ecx
	inc td1
	dec ecx
	jnz loop_each_lines
	
	
	ret
CreateWordTable endp

DestroyWordTable proc uses esi edi lpsf:Dword
	LOCAL w_cnt,l_cnt:dword
	LOCAL buff[256]:dword
	
	mov esi,lpsf
	cmp esi,0
	jnz @f
		ret				; if the handle is 0 it invalid. Dont continue.
	@@:
	; check for word count on a line
	; loop each lines
	; release each word
	
	mov ecx,[esi+16]							; line count
	mov l_cnt,0
	loop_each_lines:
	push ecx
		mov edx,[esi+28]						; esi+28 is word count array
		mov eax,l_cnt							; eax is the line counter
		mov ecx,[edx+eax*4]						; ecx is the number of word
		cmp ecx,0								; if it zero
		jz no_word								; dont continue
			mov w_cnt,0							; zero the counter
			loop_each_word:						;
			push ecx							;
				mov eax,l_cnt					;
				mov edx,[esi+24]				;
				mov edx,[edx+eax*4]				; edx point to the line array
				mov eax,w_cnt					; eax point to the word memory array
				mov ecx,[edx+eax*4]				; ecx is the word memory
				cmp dword ptr[ecx],'FFFF'		; check is it have a valid header
				jnz @f							; if not, dont continue
				invoke GlobalFree,[edx+eax*4]	; release the word information memory. it 20 byte each
				@@:			
			pop ecx								;
			inc w_cnt							;
			dec ecx								;
			jnz loop_each_word					;
			no_word:
	pop ecx
	inc l_cnt
	dec ecx
	jnz loop_each_lines
	
	
	ret
DestroyWordTable endp

GetWord proc uses esi edi lpsf:dword,colm:dword,ind:dword
	
	mov esi,lpsf
	mov edx,[esi+24]			; lplinetbl
			
	mov ecx,colm				; line count
	cmp ecx,[esi+16]
	ja no_word
	dec ecx						;
	mov edx,[edx+ecx*4]			; line structure, edx = lpword
		mov ecx,ind				; word count
		dec ecx
		mov edx,[edx+ecx*4]		; word structure, edx=the structur
		ret
	no_word:
	xor eax,eax
	dec eax
	
	ret
GetWord endp

UM_Word_Count proc uses esi edi lpsf:dword,colm:dword
	
	mov esi,lpsf
	mov ecx,colm
	dec ecx
	js error
	
	mov eax,[esi+16]
	cmp ecx,eax
	jae error
	
	mov esi,[esi+28]
	mov eax,[esi+ecx*4]
	dec eax
	ret
	error:
	xor eax,eax
	dec eax
	ret
UM_Word_Count endp

UM_LineLength proc uses esi edi lpsf:dword,dwInd:dword
	LOCAL d:dword
	
	mov esi,lpsf
	
	invoke GetOffsetTable,dwInd,[esi+8],[esi+16]
	mov d,eax
	mov eax,dwInd
	inc eax
	cmp eax,[esi+16]
	je it_last
	cmp eax,[esi+16]
	jae error
		invoke GetOffsetTable,eax,[esi+8],[esi+16]
		sub eax,d
		sub eax,2
		ret
	it_last:
	mov eax,[esi+12]
	sub eax,d
	ret
	error:
	xor eax,eax
;	dec eax
	ret
UM_LineLength endp

UMLineCount proc uses esi lpsf:dword
	mov esi,lpsf
	mov eax,[esi+16]
	dec eax
	ret
UMLineCount endp

CommandLineGetLength proc uses esi edi
	LOCAL cmdln:dword
	
	invoke GetCommandLine
	mov cmdln,eax
	mov esi,eax
	
	
	@@:
	mov al,[esi]
	inc esi
	cmp al,0
	jnz @b
	
	sub esi,cmdln
	dec esi
	
	mov edx,cmdln
	mov eax,esi
	
;	mov esi,cmdln
;	@@:
;	mov al,[esi]
;	inc esi
;	cmp al,34
;	jnz @b
	
	
	ret
CommandLineGetLength endp

CommandLineGetArg proc uses esi edi
	LOCAL cmdln:dword
	
	invoke GetCommandLine
	mov cmdln,eax
	mov esi,eax
	
	invoke CommandLineGetLength
	mov ecx,eax
	inc esi
	@@:
	mov al,[esi]
	inc esi
	dec ecx
	jz error
	cmp al,' '
	jz done
	jmp @b
	
	done:
	mov al,[esi]
	cmp al,0
	jz error
	invoke CommandLineGetLength
	; edx = text offset
	; eax = line length
	
	; length = eax-(esi-cmnd)
	; offset = esi
	
	mov edx,esi
	
	mov ecx,esi
	sub ecx,cmdln
	sub eax,ecx
	
	ret
	error:
	mov edx,cmdln
	xor eax,eax
	ret
CommandLineGetArg endp